import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import BaseComponent$1 from '../BaseComponent.js';
import { getStyles } from './ActivityItem.styles.js';
import { getClassNames } from './ActivityItem.classNames.js';
import { PersonaSize } from '../Persona/Persona.types.js';
import { PersonaCoin } from '../Persona/PersonaCoin/index.js';

var ActivityItem = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ActivityItem, _BaseComponent);

  var _super = _createSuper(ActivityItem);

  function ActivityItem() {
    var _this;

    _classCallCheck(this, ActivityItem);

    _this = _super.apply(this, arguments);
    _this.PersonaSize = PersonaSize;
    return _this;
  }

  _createClass(ActivityItem, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          activityPersonas = this.activityPersonas,
          animateBeaconSignal = this.animateBeaconSignal,
          isCompact = this.isCompact,
          personasToRender = this.personasToRender,
          personaStyle = this.personaStyle;
      return h("div", {
        "class": classNames.root
      }, [(activityPersonas || this.$slots.icon) && h("div", {
        "class": classNames.activityTypeIcon
      }, [animateBeaconSignal && isCompact && h("div", {
        "class": classNames.pulsingBeacon
      }), activityPersonas.length > 0 && h("div", {
        "class": classNames.personaContainer
      }, [personasToRender.map(function (person, index) {
        return h(PersonaCoin, {
          "props": _objectSpread2({}, person),
          "key": person.key || index,
          "class": classNames.activityPersona,
          "attrs": {
            "size": activityPersonas.length > 1 || isCompact ? PersonaSize.size16 : PersonaSize.size32
          },
          "style": personaStyle
        });
      })]), this.$slots.icon]), h("div", {
        "class": classNames.activityContent
      }, [this.$slots.activityDescription && h("span", {
        "class": classNames.activityText
      }, [this.$slots.activityDescription]), !isCompact && this.$slots.comments && h("div", {
        "class": classNames.commentText
      }, [this.$slots.comments]), !isCompact && this.$slots.timeStamp && h("div", {
        "class": classNames.timeStamp
      }, [this.$slots.timeStamp])])]);
    }
  }, {
    key: "personaStyle",
    get: function get() {
      if (!this.isCompact) return {};
      return {
        display: 'inline-block',
        width: '10px',
        minWidth: '10px',
        overflow: 'visible'
      };
    }
  }, {
    key: "personasToRender",
    get: function get() {
      var personaLimit = this.isCompact ? 3 : 4;
      return this.activityPersonas.filter(function (person, index) {
        return index < personaLimit;
      });
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className,
          activityPersonas = this.activityPersonas,
          animateBeaconSignal = this.animateBeaconSignal,
          beaconColorOne = this.beaconColorOne,
          beaconColorTwo = this.beaconColorTwo,
          isCompact = this.isCompact;
      return getClassNames(getStyles(theme, styles, animateBeaconSignal, beaconColorOne, beaconColorTwo, isCompact), className, activityPersonas, isCompact);
    }
  }]);

  return ActivityItem;
}(BaseComponent$1);

__decorate([Prop({
  type: Array,
  default: function _default() {
    return [];
  }
}), __metadata("design:type", Array)], ActivityItem.prototype, "activityPersonas", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ActivityItem.prototype, "animateBeaconSignal", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ActivityItem.prototype, "beaconColorOne", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ActivityItem.prototype, "beaconColorTwo", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ActivityItem.prototype, "isCompact", void 0);

ActivityItem = __decorate([Component({
  components: {
    PersonaCoin: PersonaCoin
  }
})], ActivityItem);

export { ActivityItem };
