import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { Icon } from '../Icon/index.js';
import { getStyles } from './Breadcrumb.styles.js';
import { Link } from '../Link/index.js';

var getClassNames = classNamesFunction();

var BreadcrumbBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(BreadcrumbBase, _BaseComponent);

  var _super = _createSuper(BreadcrumbBase);

  function BreadcrumbBase() {
    _classCallCheck(this, BreadcrumbBase);

    return _super.apply(this, arguments);
  }

  _createClass(BreadcrumbBase, [{
    key: "onBreadcrumbClicked",
    value: function onBreadcrumbClicked(event, item) {
      if (item.onClick) {
        item.onClick(event, item);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var h = arguments[0];
      var classNames = this.classNames,
          items = this.items;
      return h("div", {
        "class": classNames.root,
        "attrs": {
          "role": "navigation"
        }
      }, [h("ol", {
        "class": classNames.list
      }, [items.map(function (item, index) {
        return h("li", {
          "key": index,
          "class": classNames.listItem
        }, [item.onClick || item.href ? h(Link, {
          "class": classNames.itemLink,
          "attrs": {
            "href": item.href
          },
          "on": {
            "click": function click(ev) {
              return _this.onBreadcrumbClicked(ev, item);
            }
          }
        }, [item.text]) : h("span", {
          "class": classNames.item,
          "on": {
            "click": function click(ev) {
              return _this.onBreadcrumbClicked(ev, item);
            }
          }
        }, [item.text]), index !== items.length - 1 && h(Icon, {
          "key": "icon-".concat(index),
          "class": classNames.chevron,
          "attrs": {
            "icon-name": "ChevronRight"
          }
        })]);
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var className = this.className,
          theme = this.theme;
      return getClassNames(getStyles, {
        theme: theme,
        className: className
      });
    }
  }]);

  return BreadcrumbBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Array,
  required: true
}), __metadata("design:type", Array)], BreadcrumbBase.prototype, "items", void 0);

BreadcrumbBase = __decorate([Component], BreadcrumbBase);

export { BreadcrumbBase };
