import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import BaseComponent$1 from '../BaseComponent.js';
import { FontIcon as FontIcon$1 } from '../Icon/FontIcon.js';
import { Icon } from '../Icon/index.js';
import { DirectionalHint as DirectionalHint$1 } from '../../common/DirectionalHint.js';
import { ContextualMenu as ContextualMenu$1 } from '../ContextualMenu/ContextualMenu.js';
import { getBaseButtonClassNames } from './BaseButton.classNames.js';

/* ms */

var BaseButton = /*#__PURE__*/function (_BaseComponent) {
  _inherits(BaseButton, _BaseComponent);

  var _super = _createSuper(BaseButton);

  function BaseButton() {
    var _this;

    _classCallCheck(this, BaseButton);

    _this = _super.apply(this, arguments);
    _this.menuHidden = true;
    _this.menuOpen = false;
    return _this;
  }

  _createClass(BaseButton, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var ButtonComponent = this.component;
      var MenuComponent = this.MenuType;
      var classNames = this.classNames,
          href = this.href,
          iconProps = this.iconProps,
          className = this.className,
          css = this.css,
          secondaryText = this.secondaryText,
          isSplitButton = this.isSplitButton,
          menuProps = this.menuProps,
          menuIconProps = this.menuIconProps,
          shouldRenderMenu = this.shouldRenderMenu;
      return h(ButtonComponent, {
        "ref": "buttonElement",
        "class": classNames.root,
        "attrs": {
          "href": href
        }
      }, [h("span", {
        "class": classNames.flexContainer
      }, [iconProps && h(Icon, {
        "class": css(classNames.icon, className),
        "props": _objectSpread2({}, iconProps)
      }), this.$scopedSlots.flex ? this.$scopedSlots.flex({}) : null, this.$scopedSlots.default && h("span", {
        "class": classNames.textContainer
      }, [h("span", {
        "class": classNames.label
      }, [this.$scopedSlots.default({})]), secondaryText && h("span", {
        "class": classNames.description
      }, [secondaryText])]), !isSplitButton && menuProps && h(FontIcon$1, {
        "attrs": {
          "icon-name": "ChevronDown"
        },
        "props": _objectSpread2({}, menuIconProps),
        "class": classNames.menuIcon
      }), menuProps && !menuProps.doNotLayer && shouldRenderMenu && h(MenuComponent, {
        "attrs": {
          "directional-hint": DirectionalHint$1.bottomLeftEdge,
          "target": isSplitButton ? this.$refs.splitButtonContainer : this.$refs.buttonElement
        },
        "props": _objectSpread2({}, menuProps),
        "class": css('ms-BaseButton-menuhost', menuProps.className),
        "on": {
          "dismiss": function dismiss() {
            return _this2.menuHidden = true;
          }
        }
      })])]);
    }
  }, {
    key: "MenuType",
    get: function get() {
      return this.menuAs || ContextualMenu$1;
    }
  }, {
    key: "component",
    get: function get() {
      var disabled = this.disabled,
          href = this.href;
      var renderAsAnchor = !disabled && !!href;
      return renderAsAnchor ? 'a' : 'button';
    }
  }, {
    key: "isSplitButton",
    get: function get() {
      return !!this.menuProps && this.split === true;
    }
  }, {
    key: "shouldRenderMenu",
    get: function get() {
      var menuHidden = this.menuHidden;
      var persistMenu = this.persistMenu,
          renderPersistedMenuHiddenOnMount = this.renderPersistedMenuHiddenOnMount;

      if (!menuHidden) {
        // Always should render a menu when it is expanded
        return true;
      } else if (persistMenu && ( renderPersistedMenuHiddenOnMount)) {
        // _renderedVisibleMenu ensures that the first rendering of
        // the menu happens on-screen, as edge's scrollbar calculations are off if done while hidden.
        return true;
      }

      return false;
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          styles = this.styles,
          className = this.className,
          iconProps = this.iconProps,
          menuIconProps = this.menuIconProps,
          variantClassName = this.variantClassName,
          disabled = this.disabled,
          primaryDisabled = this.primaryDisabled,
          checked = this.checked,
          getClassNames = this.getClassNames;
      var isPrimaryButtonDisabled = disabled || primaryDisabled;
      return getClassNames ? getClassNames(theme, className, variantClassName, iconProps && iconProps.className, menuIconProps && menuIconProps.className, isPrimaryButtonDisabled, checked, !this.menuHidden, !!this.menuProps, this.split, !!this.allowDisabledFocus) : getBaseButtonClassNames(theme, styles, className, variantClassName, iconProps && iconProps.className, menuIconProps && menuIconProps.className, isPrimaryButtonDisabled, !!this.menuProps, checked, !this.menuHidden, this.split);
    }
  }]);

  return BaseButton;
}(BaseComponent$1);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], BaseButton.prototype, "href", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], BaseButton.prototype, "checked", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], BaseButton.prototype, "split", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], BaseButton.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], BaseButton.prototype, "primaryDisabled", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], BaseButton.prototype, "allowDisabledFocus", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], BaseButton.prototype, "variantClassName", void 0);

__decorate([Prop({
  type: Object,
  default: function _default() {}
}), __metadata("design:type", Object)], BaseButton.prototype, "iconProps", void 0);

__decorate([Prop({
  type: Object,
  default: function _default() {}
}), __metadata("design:type", Object)], BaseButton.prototype, "menuIconProps", void 0);

__decorate([Prop({
  type: Object,
  default: null
}), __metadata("design:type", Object)], BaseButton.prototype, "menuAs", void 0);

__decorate([Prop({
  type: Object,
  default: null
}), __metadata("design:type", Object)], BaseButton.prototype, "menuProps", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], BaseButton.prototype, "persistMenu", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], BaseButton.prototype, "renderPersistedMenuHiddenOnMount", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], BaseButton.prototype, "secondaryText", void 0);

__decorate([Prop({
  type: Function,
  default: null
}), __metadata("design:type", Function)], BaseButton.prototype, "getClassNames", void 0);

BaseButton = __decorate([Component], BaseButton);

export { BaseButton };
