import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Model, Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import _mergeJSXProps$1 from '@vue/babel-helper-vue-jsx-merge-props';
import { Icon } from '../Icon/index.js';
import { Label } from '../Label/index.js';

var getClassNames = classNamesFunction();

var CheckboxBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(CheckboxBase, _BaseComponent);

  var _super = _createSuper(CheckboxBase);

  function CheckboxBase() {
    var _this;

    _classCallCheck(this, CheckboxBase);

    _this = _super.apply(this, arguments);
    _this.internalValue = _this.checked || _this.defaultChecked;
    _this.isIndeterminate = _this.indeterminate || _this.defaultIndeterminate;
    return _this;
  }

  _createClass(CheckboxBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          title = this.title,
          label = this.label;
      return h("div", {
        "class": classNames.root
      }, [h("input", _mergeJSXProps$1([{
        "attrs": {
          "id": "Checkbox".concat(this.uid)
        },
        "class": classNames.input
      }, this.$attrs, {
        "attrs": {
          "disabled": this.disabled,
          "type": "checkbox"
        },
        "on": {
          "input": this.onInput
        }
      }])), h(Label, {
        "class": classNames.label,
        "attrs": {
          "for": "Checkbox".concat(this.uid)
        }
      }, [h("div", {
        "class": classNames.checkbox
      }, [h(Icon, {
        "attrs": {
          "icon-name": "CheckMark"
        },
        "class": classNames.checkmark
      })]), (label || this.$slots.default) && h("span", {
        "class": classNames.text,
        "attrs": {
          "title": title
        }
      }, [this.$slots.default || label])])]);
    }
  }, {
    key: "onCheckedChanged",
    value: function onCheckedChanged(newVal, oldVal) {
      if (newVal === oldVal) return;
      this.internalValue = newVal;
    }
  }, {
    key: "onValueChanged",
    value: function onValueChanged(value) {
      this.$emit('input', value);
    }
  }, {
    key: "onInput",
    value: function onInput() {
      if (this.disabled) return;

      if (this.isIndeterminate) {
        this.internalValue = this.defaultChecked;
        this.isIndeterminate = false;
      } else {
        this.internalValue = !this.internalValue;
      }
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          className = this.className,
          disabled = this.disabled,
          isIndeterminate = this.isIndeterminate,
          internalValue = this.internalValue,
          boxSide = this.boxSide;
      return getClassNames(this.styles, {
        theme: theme,
        className: className,
        disabled: disabled,
        indeterminate: isIndeterminate,
        checked: internalValue,
        reversed: boxSide !== 'start',
        isUsingCustomLabelRender: true
      });
    }
  }]);

  return CheckboxBase;
}(BaseComponent$1);

__decorate([Model('input', {
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], CheckboxBase.prototype, "checked", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], CheckboxBase.prototype, "defaultChecked", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], CheckboxBase.prototype, "indeterminate", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], CheckboxBase.prototype, "defaultIndeterminate", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], CheckboxBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], CheckboxBase.prototype, "required", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], CheckboxBase.prototype, "label", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], CheckboxBase.prototype, "title", void 0);

__decorate([Prop({
  type: String,
  default: 'start',
  validator: function validator(v) {
    return ['start', 'end'].indexOf(v) > -1;
  }
}), __metadata("design:type", String)], CheckboxBase.prototype, "boxSide", void 0);

__decorate([Watch('checked'), __metadata("design:type", Function), __metadata("design:paramtypes", [Object, Object]), __metadata("design:returntype", void 0)], CheckboxBase.prototype, "onCheckedChanged", null);

__decorate([Watch('internalValue'), __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean]), __metadata("design:returntype", void 0)], CheckboxBase.prototype, "onValueChanged", null);

CheckboxBase = __decorate([Component({})], CheckboxBase);

export { CheckboxBase };
