import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { Label } from '../Label/index.js';
import { ChoiceGroupOption } from './ChoiceGroupOption/index.js';

var getClassNames = classNamesFunction();

var ChoiceGroupBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ChoiceGroupBase, _BaseComponent);

  var _super = _createSuper(ChoiceGroupBase);

  function ChoiceGroupBase() {
    var _this;

    _classCallCheck(this, ChoiceGroupBase);

    _this = _super.apply(this, arguments);
    _this.selectedOption = {};
    return _this;
  }

  _createClass(ChoiceGroupBase, [{
    key: "onClick",
    value: function onClick(ev, option) {
      ev.preventDefault();
      if (option.disabled) return;
      this.selectedOption = option;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var classNames = this.classNames,
          label = this.label,
          required = this.required,
          disabled = this.disabled,
          selectedOption = this.selectedOption,
          options = this.options;
      return h("div", {
        "class": classNames.applicationRole
      }, [h("div", {
        "class": classNames.root
      }, [label && h(Label, {
        "class": classNames.label,
        "attrs": {
          "required": required,
          "disabled": disabled
        }
      }, [label]), h("div", {
        "class": classNames.flexContainer
      }, [options.map(function (option) {
        return h(ChoiceGroupOption, {
          "attrs": {
            "id": option.key,
            "checked": selectedOption.key === option.key
          },
          "key": option.key,
          "props": _objectSpread2({}, option),
          "nativeOn": {
            "click": function click(ev) {
              return _this2.onClick(ev, option);
            }
          }
        }, [option.text]);
      })])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        optionsContainIconOrImage: false
      });
    }
  }]);

  return ChoiceGroupBase;
}(BaseComponent$1);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ChoiceGroupBase.prototype, "label", void 0);

__decorate([Prop({
  type: Array,
  default: function _default() {
    return [];
  }
}), __metadata("design:type", Array)], ChoiceGroupBase.prototype, "options", void 0);

__decorate([Prop({
  type: Array,
  default: function _default() {
    return [];
  }
}), __metadata("design:type", Array)], ChoiceGroupBase.prototype, "value", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ChoiceGroupBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ChoiceGroupBase.prototype, "required", void 0);

ChoiceGroupBase = __decorate([Component({
  components: {
    ChoiceGroupOption: ChoiceGroupOption,
    Label: Label
  }
})], ChoiceGroupBase);

export { ChoiceGroupBase };
