import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../../BaseComponent.js';
import { Image } from '../../Image/index.js';
import { Icon } from '../../Icon/index.js';

var getClassNames = classNamesFunction();

var ChoiceGroupOptionBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ChoiceGroupOptionBase, _BaseComponent);

  var _super = _createSuper(ChoiceGroupOptionBase);

  function ChoiceGroupOptionBase() {
    _classCallCheck(this, ChoiceGroupOptionBase);

    return _super.apply(this, arguments);
  }

  _createClass(ChoiceGroupOptionBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var id = this.id,
          classNames = this.classNames,
          text = this.text,
          imageSrc = this.imageSrc,
          imageAlt = this.imageAlt,
          imageSize = this.imageSize,
          selectedImageSrc = this.selectedImageSrc,
          iconProps = this.iconProps,
          disabled = this.disabled;
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.choiceFieldWrapper
      }, [h("input", {
        "attrs": {
          "id": "ChoiceGroup".concat(this.uid, "-").concat(id),
          "name": "ChoiceGroup".concat(this.uid),
          "disabled": this.disabled,
          "type": "radio"
        },
        "class": classNames.input
      }), h("label", {
        "attrs": {
          "for": "ChoiceGroup".concat(this.uid, "-").concat(id)
        },
        "class": classNames.field
      }, [imageSrc && h("div", {
        "class": classNames.innerField
      }, [h("div", {
        "class": classNames.imageWrapper
      }, [h(Image, {
        "attrs": {
          "src": imageSrc,
          "alt": imageAlt,
          "width": imageSize.width,
          "height": imageSize.height
        }
      })]), h("div", {
        "class": classNames.selectedImageWrapper
      }, [h(Image, {
        "attrs": {
          "src": selectedImageSrc,
          "alt": imageAlt,
          "width": imageSize.width,
          "height": imageSize.height
        }
      })])]), iconProps && h("div", {
        "class": classNames.innerField
      }, [h("div", {
        "class": classNames.iconWrapper
      }, [h(Icon, {
        "props": _objectSpread2({}, iconProps)
      })])]), imageSrc || iconProps ? h("div", {
        "class": classNames.labelWrapper
      }, [h("span", {
        "class": "ms-ChoiceFieldLabel"
      }, [this.$slots.default || text])]) : h("span", {
        "class": "ms-ChoiceFieldLabel"
      }, [this.$slots.default || text])])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          iconProps = this.iconProps,
          imageSrc = this.imageSrc,
          checked = this.checked,
          disabled = this.disabled,
          imageSize = this.imageSize,
          focused = this.focused;
      return getClassNames(styles, {
        theme: theme,
        hasIcon: !!iconProps,
        hasImage: !!imageSrc,
        checked: checked,
        disabled: disabled,
        imageIsLarge: !!imageSrc && (imageSize.width > 71 || imageSize.height > 71),
        imageSize: imageSize,
        focused: focused
      });
    }
  }]);

  return ChoiceGroupOptionBase;
}(BaseComponent$1);

__decorate([Prop(), __metadata("design:type", String)], ChoiceGroupOptionBase.prototype, "id", void 0);

__decorate([Prop(), __metadata("design:type", String)], ChoiceGroupOptionBase.prototype, "text", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "iconProps", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "imageSrc", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "selectedImageSrc", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "imageAlt", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ChoiceGroupOptionBase.prototype, "checked", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ChoiceGroupOptionBase.prototype, "disabled", void 0);

__decorate([Prop({
  default: function _default() {
    return {
      width: 32,
      height: 32
    };
  }
}), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "imageSize", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ChoiceGroupOptionBase.prototype, "focused", void 0);

ChoiceGroupOptionBase = __decorate([Component], ChoiceGroupOptionBase);

export { ChoiceGroupOptionBase };
