import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction, css } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { DirectionalHint as DirectionalHint$1 } from '../../common/DirectionalHint.js';
import { Callout as Callout$1 } from '../Callout/Callout.js';
import { ContextualMenuItem as ContextualMenuItem$1 } from './ContextualMenuItem.js';

var getClassNames = classNamesFunction({
  disableCaching: true
});

var ContextualMenuBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ContextualMenuBase, _BaseComponent);

  var _super = _createSuper(ContextualMenuBase);

  function ContextualMenuBase() {
    _classCallCheck(this, ContextualMenuBase);

    return _super.apply(this, arguments);
  }

  _createClass(ContextualMenuBase, [{
    key: "created",
    value: function created() {
      console.log(this.target);
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var target = this.target,
          directionalHint = this.directionalHint,
          calloutProps = this.calloutProps,
          onDismiss = this.onDismiss,
          contextMenuStyle = this.contextMenuStyle,
          classNames = this.classNames,
          items = this.items;
      return h(Callout$1, {
        "attrs": {
          "target": target,
          "directional-hint": directionalHint,
          "is-beak-visible": false
        },
        "class": css('ms-ContextualMenu-Callout', calloutProps && calloutProps.className),
        "on": {
          "dismiss": onDismiss
        }
      }, [h("div", {
        "style": contextMenuStyle,
        "class": classNames.container
      }, [h("div", {
        "class": classNames.root
      }, [h("ul", {
        "class": classNames.list,
        "attrs": {
          "role": "menu"
        }
      }, [items.map(function (item, index) {
        return h("li", {
          "key": item.key || index,
          "class": classNames.item
        }, [h(ContextualMenuItem$1, {
          "attrs": {
            "item": item,
            "prop-class-names": classNames
          }
        })]);
      })])])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className;
      return getClassNames(styles, {
        theme: theme,
        className: className
      });
    }
  }, {
    key: "contextMenuStyle",
    get: function get() {
      var targetBoundingRect = this.target.getBoundingClientRect();
      var targetWidth = targetBoundingRect.width - 2;
      /* Accounts for 1px border */

      return {
        width: "".concat(targetWidth, "px")
      };
    }
  }]);

  return ContextualMenuBase;
}(BaseComponent$1);

__decorate([Prop(), __metadata("design:type", HTMLElement)], ContextualMenuBase.prototype, "target", void 0);

__decorate([Prop({
  type: Object,
  default: function _default() {}
}), __metadata("design:type", Object)], ContextualMenuBase.prototype, "calloutProps", void 0);

__decorate([Prop({
  type: Number,
  default: DirectionalHint$1.bottomAutoEdge
}), __metadata("design:type", Boolean)], ContextualMenuBase.prototype, "directionalHint", void 0);

__decorate([Prop({
  type: Function,
  default: function _default() {
    return null;
  }
}), __metadata("design:type", Function)], ContextualMenuBase.prototype, "onDismiss", void 0);

__decorate([Prop({
  type: Array,
  default: function _default() {
    return [];
  }
}), __metadata("design:type", Array)], ContextualMenuBase.prototype, "items", void 0);

ContextualMenuBase = __decorate([Component({
  components: {
    Callout: Callout$1,
    ContextualMenuItem: ContextualMenuItem$1
  }
})], ContextualMenuBase);

export { ContextualMenuBase };
