import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../../BaseComponent.js';
import _mergeJSXProps$1 from '@vue/babel-helper-vue-jsx-merge-props';
import { DetailsRowFields as DetailsRowFields$1 } from './DetailsRowFields.js';

var getClassNames = classNamesFunction();
var NO_COLUMNS = [];

var DetailsRowBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(DetailsRowBase, _BaseComponent);

  var _super = _createSuper(DetailsRowBase);

  function DetailsRowBase() {
    var _this;

    _classCallCheck(this, DetailsRowBase);

    _this = _super.apply(this, arguments);
    _this.showCheckbox = false;
    return _this;
  }

  _createClass(DetailsRowBase, [{
    key: "measureCell",

    /**
     * measure cell at index. and call the call back with the measured cell width when finish measure
     *
     * @param index - The cell index
     * @param onMeasureDone - The call back function when finish measure
     */
    value: function measureCell(index, onMeasureDone) {
      var _this$columns = this.columns,
          columns = _this$columns === void 0 ? NO_COLUMNS : _this$columns;

      var column = _objectSpread2({}, columns[index]);

      column.minWidth = 0;
      column.maxWidth = 999999;
      delete column.calculatedWidth; // this.setState({
      //   columnMeasureInfo: {
      //     index,
      //     column,
      //     onMeasureDone,
      //   },
      // })
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          rowClassNames = this.rowClassNames,
          item = this.item,
          columns = this.columns,
          showCheckbox = this.showCheckbox;
      return h("div", {
        "class": classNames.root
      }, [h(DetailsRowFields$1, _mergeJSXProps$1([{
        "attrs": {
          "row-class-names": rowClassNames,
          "columns": columns,
          "item": item,
          "item-index": 0,
          "column-start-index": showCheckbox ? 1 : 0
        }
      }, {
        scopedSlots: this.$scopedSlots
      }]))]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className,
          compact = this.compact;
      return _objectSpread2({}, getClassNames(styles, {
        theme: theme,
        isSelected: false,
        canSelect: false,
        anySelected: false,
        checkboxCellClassName: '',
        droppingClassName: '',
        className: className,
        compact: compact,
        enableUpdateAnimations: false
      }));
    }
  }, {
    key: "rowClassNames",
    get: function get() {
      return {
        isMultiline: this.classNames.isMultiline,
        isRowHeader: this.classNames.isRowHeader,
        cell: this.classNames.cell,
        cellAnimation: this.classNames.cellAnimation,
        cellPadded: this.classNames.cellPadded,
        cellUnpadded: this.classNames.cellUnpadded,
        fields: this.classNames.fields
      };
    }
  }]);

  return DetailsRowBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Array,
  required: true
}), __metadata("design:type", Array)], DetailsRowBase.prototype, "columns", void 0);

__decorate([Prop({
  type: Object,
  required: true
}), __metadata("design:type", Object)], DetailsRowBase.prototype, "item", void 0);

__decorate([Prop({
  type: Boolean,
  required: true
}), __metadata("design:type", Boolean)], DetailsRowBase.prototype, "compact", void 0);

DetailsRowBase = __decorate([Component], DetailsRowBase);

export { DetailsRowBase };
