import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { css } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../../BaseComponent.js';
import { DEFAULT_CELL_STYLE_PROPS } from './DetailsRow.styles.js';

var getCellText = function getCellText(item, column) {
  var value = item && column && column.fieldName ? item[column.fieldName] : '';

  if (value === null || value === undefined) {
    value = '';
  }

  if (typeof value === 'boolean') {
    return value.toString();
  }

  return value;
};

var DetailsRowFields = /*#__PURE__*/function (_BaseComponent) {
  _inherits(DetailsRowFields, _BaseComponent);

  var _super = _createSuper(DetailsRowFields);

  function DetailsRowFields() {
    var _this;

    _classCallCheck(this, DetailsRowFields);

    _this = _super.apply(this, arguments);
    _this.showAnimation = true;
    return _this;
  }

  _createClass(DetailsRowFields, [{
    key: "calcWidth",
    value: function calcWidth(column) {
      var cellStyleProps = this.cellStyleProps;
      var width = typeof column.calculatedWidth === 'undefined' ? 'auto' : column.calculatedWidth + cellStyleProps.cellLeftPadding + cellStyleProps.cellRightPadding + (column.isPadded ? cellStyleProps.cellExtraRightPadding : 0) + 'px';
      return width;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var rowClassNames = this.rowClassNames,
          columns = this.columns,
          showAnimation = this.showAnimation,
          item = this.item;
      return h("div", {
        "class": rowClassNames.fields,
        "attrs": {
          "role": "presentation"
        }
      }, [columns.map(function (column, columnIndex) {
        return h("div", {
          "key": columnIndex,
          "attrs": {
            "role": column.isRowHeader ? 'rowheader' : 'gridcell',
            "aria-readonly": true
          },
          "style": {
            width: _this2.calcWidth(column)
          },
          "class": css(column.className, column.isMultiline && rowClassNames.isMultiline, column.isRowHeader && rowClassNames.isRowHeader, rowClassNames.cell, column.isPadded ? rowClassNames.cellPadded : rowClassNames.cellUnpadded, showAnimation && rowClassNames.cellAnimation)
        }, [_this2.$scopedSlots["cell.".concat(column.key)] ? _this2.$scopedSlots["cell.".concat(column.key)]({
          item: item,
          column: column
        }) : getCellText(item, column)]);
      })]);
    }
  }]);

  return DetailsRowFields;
}(BaseComponent$1);

__decorate([Prop({
  type: Object,
  required: true
}), __metadata("design:type", Object)], DetailsRowFields.prototype, "rowClassNames", void 0);

__decorate([Prop({
  type: Array,
  required: true
}), __metadata("design:type", Array)], DetailsRowFields.prototype, "columns", void 0);

__decorate([Prop({
  type: Object,
  required: true
}), __metadata("design:type", Object)], DetailsRowFields.prototype, "item", void 0);

__decorate([Prop({
  type: Number,
  required: true
}), __metadata("design:type", Number)], DetailsRowFields.prototype, "itemIndex", void 0);

__decorate([Prop({
  type: Object,
  default: function _default() {
    return DEFAULT_CELL_STYLE_PROPS;
  }
}), __metadata("design:type", Object)], DetailsRowFields.prototype, "cellStyleProps", void 0);

DetailsRowFields = __decorate([Component], DetailsRowFields);

export { DetailsRowFields };
