import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import _mergeJSXProps$1 from '@vue/babel-helper-vue-jsx-merge-props';
import { Layer as Layer$1 } from '../Layer/Layer.js';
import { Modal as Modal$1 } from '../Modal/Modal.js';
import { DialogType } from './DialogContent.types.js';
import { DialogContent as DialogContent$1 } from './DialogContent.js';

var getClassNames = classNamesFunction();
var DefaultModalProps = {
  isDarkOverlay: false,
  isBlocking: false,
  className: '',
  containerClassName: '',
  topOffsetFixed: false
};
var DefaultDialogContentProps = {
  type: DialogType.normal,
  className: '',
  topButtonsProps: []
};

var DialogBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(DialogBase, _BaseComponent);

  var _super = _createSuper(DialogBase);

  function DialogBase() {
    _classCallCheck(this, DialogBase);

    return _super.apply(this, arguments);
  }

  _createClass(DialogBase, [{
    key: "render",
    value: function render() {
      var _this = this,
          _this$dialogContentPr;

      var h = arguments[0];
      var classNames = this.classNames,
          mergedModalProps = this.mergedModalProps,
          hidden = this.hidden,
          responsiveMode = this.responsiveMode;

      var onDismiss = function onDismiss(ev) {
        return _this.$emit('dismiss', ev);
      };

      var dialogContentProps = _objectSpread2(_objectSpread2(_objectSpread2({}, DefaultDialogContentProps), this.dialogContentProps), {}, {
        // draggableHeaderClassName: dialogDraggableClassName,
        titleProps: _objectSpread2({
          // tslint:disable-next-line:deprecation
          id: this._getTitleTextId()
        }, (_this$dialogContentPr = this.dialogContentProps) === null || _this$dialogContentPr === void 0 ? void 0 : _this$dialogContentPr.titleProps)
      });

      return h(Modal$1, _mergeJSXProps$1([{
        "attrs": {
          "responsiveMode": responsiveMode
        }
      }, mergedModalProps, {
        "attrs": {
          "isDarkOverlay": mergedModalProps.isDarkOverlay,
          "isBlocking": mergedModalProps.isBlocking,
          "isOpen": !hidden,
          "containerClassName": classNames.main,
          "subtitleAriaId": this._getSubTextId(),
          "titleAriaId": this._getTitleTextId()
        },
        "class": classNames.root,
        "on": {
          "dismiss": onDismiss || mergedModalProps.onDismiss
        }
      }]), [h(DialogContent$1, _mergeJSXProps$1([{
        "attrs": {
          "subTextId": this._getSubTextId(),
          "title": dialogContentProps.title,
          "subText": dialogContentProps.subText,
          "showCloseButton": mergedModalProps.isBlocking,
          "topButtonsProps": dialogContentProps.topButtonsProps,
          "type": dialogContentProps.type
        },
        "on": {
          "dismiss": onDismiss || dialogContentProps.onDismiss
        },
        "class": dialogContentProps.className
      }, dialogContentProps]), [this.$slots.default])]);
    }
  }, {
    key: "_getSubTextId",
    value: function _getSubTextId() {
      return "".concat(this.uid, "-subText"); // // tslint:disable-next-line:deprecation
      // const { ariaDescribedById, modalProps, dialogContentProps, subText } = this.props
      // let id = (modalProps && modalProps.subtitleAriaId) || ariaDescribedById
      // if (!id) {
      //   id = ((dialogContentProps && dialogContentProps.subText) || subText) && this._defaultSubTextId
      // }
      // return id
    }
  }, {
    key: "_getTitleTextId",
    value: function _getTitleTextId() {
      return "".concat(this.uid, "-title"); // // tslint:disable-next-line:deprecation
      // const { ariaLabelledById, modalProps, dialogContentProps, title } = this.props
      // let id = (modalProps && modalProps.titleAriaId) || ariaLabelledById
      // if (!id) {
      //   id = ((dialogContentProps && dialogContentProps.title) || title) && this._defaultTitleTextId
      // }
      // return id
    }
  }, {
    key: "mergedLayerProps",
    get: function get() {
      var modalProps = this.modalProps,
          onLayerDidMount = this.onLayerDidMount;

      var mergedLayerProps = _objectSpread2({}, modalProps ? modalProps.layerProps : {
        onLayerDidMount: onLayerDidMount
      });

      if (onLayerDidMount && !mergedLayerProps.onLayerDidMount) {
        mergedLayerProps.onLayerDidMount = onLayerDidMount;
      }

      return mergedLayerProps;
    }
  }, {
    key: "dragOptions",
    get: function get() {
      var modalProps = this.modalProps;
      var dialogDraggableClassName;
      var dragOptions; // if we are draggable, make sure we are using the correct
      // draggable classname and selectors

      if (modalProps && modalProps.dragOptions && !modalProps.dragOptions.dragHandleSelector) {
        dialogDraggableClassName = 'ms-Dialog-draggable-header';
        dragOptions = _objectSpread2(_objectSpread2({}, modalProps.dragOptions), {}, {
          dragHandleSelector: ".".concat(dialogDraggableClassName)
        });
      } else {
        dragOptions = modalProps && modalProps.dragOptions;
      }

      return dragOptions;
    }
  }, {
    key: "mergedModalProps",
    get: function get() {
      var className = this.className,
          modalProps = this.modalProps,
          dragOptions = this.dragOptions;
      return _objectSpread2(_objectSpread2(_objectSpread2({
        className: className
      }, DefaultModalProps), modalProps), {}, {
        layerProps: this.mergedLayerProps,
        dragOptions: dragOptions
      });
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          mergedModalProps = this.mergedModalProps,
          hidden = this.hidden,
          minWidth = this.minWidth,
          maxWidth = this.maxWidth;
      return getClassNames(styles, {
        theme: theme,
        className: mergedModalProps.className,
        hidden: hidden,
        dialogDefaultMinWidth: minWidth,
        dialogDefaultMaxWidth: maxWidth
      });
    }
  }]);

  return DialogBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Object,
  default: function _default() {}
}), __metadata("design:type", Object)], DialogBase.prototype, "dialogContentProps", void 0);

__decorate([Prop({
  type: Boolean,
  default: true
}), __metadata("design:type", Boolean)], DialogBase.prototype, "hidden", void 0);

__decorate([Prop({
  type: Object,
  default: null
}), __metadata("design:type", Object)], DialogBase.prototype, "modalProps", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", Object)], DialogBase.prototype, "minWidth", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", Object)], DialogBase.prototype, "maxWidth", void 0);

__decorate([Prop({
  type: Function,
  default: null
}), __metadata("design:type", Object)], DialogBase.prototype, "onLayerDidMount", void 0);

__decorate([Prop({
  type: Number,
  default: null
}), __metadata("design:type", Number)], DialogBase.prototype, "responsiveMode", void 0);

DialogBase = __decorate([Component({
  components: {
    Layer: Layer$1
  }
})], DialogBase);

export { DialogBase };
