import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import _mergeJSXProps$1 from '@vue/babel-helper-vue-jsx-merge-props';
import { IconButton as IconButton$1 } from '../Button/IconButton/IconButton.js';
import { DialogType } from './DialogContent.types.js';

var getClassNames = classNamesFunction();

var DialogContentBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(DialogContentBase, _BaseComponent);

  var _super = _createSuper(DialogContentBase);

  function DialogContentBase() {
    _classCallCheck(this, DialogContentBase);

    return _super.apply(this, arguments);
  }

  _createClass(DialogContentBase, [{
    key: "render",
    value: function render() {
      var _this = this;

      var h = arguments[0];
      var classNames = this.classNames,
          css = this.css,
          title = this.title,
          type = this.type,
          showCloseButton = this.showCloseButton,
          closeButtonAriaLabel = this.closeButtonAriaLabel,
          subText = this.subText,
          subTextId = this.subTextId;
      var titleProps = this.titleProps || {};
      var subTextContent;

      if (subText) {
        subTextContent = h("p", {
          "class": classNames.subText,
          "attrs": {
            "id": subTextId
          }
        }, [subText]);
      }

      return h("div", {
        "class": classNames.content
      }, [h("div", {
        "class": classNames.header
      }, [h("div", _mergeJSXProps$1([{
        "attrs": {
          "id": titleProps.id,
          "role": "heading",
          "aria-level": 1
        }
      }, titleProps, {
        "class": css(classNames.title, titleProps.className)
      }]), [title]), h("div", {
        "class": classNames.topButton
      }, [(type === DialogType.close || showCloseButton && type !== DialogType.largeHeader) && h(IconButton$1, {
        "class": classNames.button,
        "attrs": {
          "iconProps": {
            iconName: 'Cancel'
          },
          "ariaLabel": closeButtonAriaLabel,
          "title": closeButtonAriaLabel
        },
        "on": {
          "click": function click(ev) {
            return _this.$emit('dismiss', ev);
          }
        }
      })])]), h("div", {
        "class": classNames.inner
      }, [h("div", {
        "class": classNames.innerContent
      }, [subTextContent, this.$slots.default]), this.$slots.footer])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className,
          type = this.type,
          draggableHeaderClassName = this.draggableHeaderClassName;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        isLargeHeader: type === DialogType.largeHeader,
        isClose: type === DialogType.close,
        draggableHeaderClassName: draggableHeaderClassName
      });
    }
  }]);

  return DialogContentBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Number,
  default: DialogType.normal
}), __metadata("design:type", Number)], DialogContentBase.prototype, "type", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], DialogContentBase.prototype, "draggableHeaderClassName", void 0);

__decorate([Prop({
  type: Object,
  default: function _default() {}
}), __metadata("design:type", Object)], DialogContentBase.prototype, "titleProps", void 0);

__decorate([Prop({
  type: [String, Object],
  default: null
}), __metadata("design:type", Object)], DialogContentBase.prototype, "title", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], DialogContentBase.prototype, "showCloseButton", void 0);

__decorate([Prop({
  type: String,
  default: 'Close'
}), __metadata("design:type", String)], DialogContentBase.prototype, "closeButtonAriaLabel", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], DialogContentBase.prototype, "subText", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], DialogContentBase.prototype, "subTextId", void 0);

DialogContentBase = __decorate([Component], DialogContentBase);

export { DialogContentBase };
