import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { PersonaSize } from '../Persona/Persona.types.js';
import { FacepileButton as FacepileButton$1 } from './FacepileButton/FacepileButton.js';
import { Persona } from '../Persona/index.js';

var getClassNames = classNamesFunction();

var FacepileBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(FacepileBase, _BaseComponent);

  var _super = _createSuper(FacepileBase);

  function FacepileBase() {
    _classCallCheck(this, FacepileBase);

    return _super.apply(this, arguments);
  }

  _createClass(FacepileBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          personas = this.personas,
          singlePersona = this.singlePersona,
          personaSize = this.personaSize;
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.itemContainer
      }, [h("ul", {
        "class": classNames.members,
        "attrs": {
          "role": "listbox"
        }
      }, [personas.map(function (persona, index) {
        return h("li", {
          "key": singlePersona ? 'persona' : "personaCoin-".concat(index),
          "class": classNames.member,
          "attrs": {
            "role": "option"
          }
        }, [h("div", {
          "class": classNames.itemButton,
          "attrs": {
            "title": persona.personaName
          }
        }, [h(Persona, {
          "props": _objectSpread2({}, persona),
          "attrs": {
            "image-initials": persona.imageInitials,
            "image-url": persona.imageUrl,
            "initials-color": persona.initialsColor,
            "allow-phone-initials": persona.allowPhoneInitials,
            "text": persona.personaName,
            "presence": 2,
            "size": personaSize,
            "styles": {
              details: {
                flex: '1 0 auto'
              }
            }
          }
        })])]);
      })])])]);
    }
  }, {
    key: "singlePersona",
    get: function get() {
      return this.personas.length === 1;
    }
  }, {
    key: "classNames",
    get: function get() {
      return getClassNames(this.styles, {
        theme: this.theme,
        className: this.className
      });
    }
  }]);

  return FacepileBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Array,
  default: function _default() {
    return [];
  }
}), __metadata("design:type", Array)], FacepileBase.prototype, "personas", void 0);

__decorate([Prop({
  type: Number,
  default: PersonaSize.size32
}), __metadata("design:type", Number)], FacepileBase.prototype, "personaSize", void 0);

FacepileBase = __decorate([Component({
  components: {
    FacepileButton: FacepileButton$1,
    Persona: Persona
  }
})], FacepileBase);

export { FacepileBase };
