import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { memoizeFunction, css } from '@uifabric-vue/utilities';
import { getIcon } from '@uifabric/styling';
import StatelessComponent$1 from '../StatelessComponent.js';
import { MS_ICON, classNames } from './Icon.styles.js';

var getIconContent = memoizeFunction(function (iconName) {
  var _ref = getIcon(iconName) || {
    subset: {},
    code: undefined
  },
      code = _ref.code,
      subset = _ref.subset;

  if (!code) {
    return null;
  }

  return {
    children: code,
    iconClassName: subset.className,
    fontFamily: subset.fontFace && subset.fontFace.fontFamily
  };
}, undefined, // @ts-ignore
true);

var FontIcon = /*#__PURE__*/function (_StatelessComponent) {
  _inherits(FontIcon, _StatelessComponent);

  var _super = _createSuper(FontIcon);

  function FontIcon() {
    _classCallCheck(this, FontIcon);

    return _super.apply(this, arguments);
  }

  _createClass(FontIcon, [{
    key: "render",
    value: function render(h, ctx) {
      var className = ctx.props.className || ctx.data.class;
      var _ctx$props = ctx.props,
          iconName = _ctx$props.iconName,
          _ctx$props$style = _ctx$props.style,
          style = _ctx$props$style === void 0 ? {} : _ctx$props$style;
      var iconContent = getIconContent(iconName) || {};
      var children = iconContent.children;
      var iconClassName = iconContent.iconClassName,
          fontFamily = iconContent.fontFamily;
      return h("i", {
        "class": css(MS_ICON, classNames.root, iconClassName, !iconName && classNames.placeholder, className),
        "style": _objectSpread2({
          fontFamily: fontFamily
        }, style)
      }, [typeof children === 'function' ? children(h) : children]);
    }
  }]);

  return FontIcon;
}(StatelessComponent$1);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], FontIcon.prototype, "iconName", void 0);

FontIcon = __decorate([Component], FontIcon);

export { FontIcon, getIconContent };
