import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent$1 from '../StatelessComponent.js';
import _mergeJSXProps$1 from '@vue/babel-helper-vue-jsx-merge-props';
import { getIconContent } from './FontIcon.js';
import { ImageLoadState } from '../Image/Image.types.js';

var getClassNames = classNamesFunction({
  // Icon is used a lot by other components.
  // It's likely to see expected cases which pass different className to the Icon.
  // Therefore setting a larger cache size.
  cacheSize: 100
});

var Icon = /*#__PURE__*/function (_StatelessComponent) {
  _inherits(Icon, _StatelessComponent);

  var _super = _createSuper(Icon);

  function Icon() {
    _classCallCheck(this, Icon);

    return _super.apply(this, arguments);
  }

  _createClass(Icon, [{
    key: "render",
    value: function render(h, ctx) {
      var _ctx$props = ctx.props,
          className = _ctx$props.className,
          iconName = _ctx$props.iconName,
          theme = _ctx$props.theme,
          styles = _ctx$props.styles,
          imageErrorAs = _ctx$props.imageErrorAs;
      var isPlaceholder = typeof iconName === 'string' && iconName.length === 0;
      var isImage = !!ctx.props.imageProps;
      var iconContent = getIconContent(iconName) || {};
      var iconClassName = iconContent.iconClassName;
      var iconContentChildren = iconContent.children;
      var classNames = getClassNames(styles, {
        theme: theme,
        className: className,
        iconClassName: iconClassName,
        isImage: isImage,
        isPlaceholder: isPlaceholder
      });
      var RootType = isImage ? 'span' : 'i';
      var imageLoadError = false;

      var imageProps = _objectSpread2(_objectSpread2({}, ctx.props.imageProps), {}, {
        onLoadingStateChange: function onLoadingStateChange(state) {
          if (ctx.props.imageProps && ctx.props.imageProps.onLoadingStateChange) {
            ctx.props.imageProps.onLoadingStateChange(state);
          }

          if (state === ImageLoadState.error) {
            imageLoadError = true;
          }
        }
      });

      var ImageType = imageLoadError && imageErrorAs || Image;
      var ariaLabel = ctx.data.attrs && (ctx.data.attrs['aria-label'] || ctx.data.attrs.ariaLabel);
      var containerProps = ariaLabel ? {
        'aria-label': ariaLabel
      } : {
        'aria-hidden': !(ctx.props['aria-labelledby'] || imageProps['aria-labelledby'])
      };
      return h(RootType, _mergeJSXProps$1([{
        "attrs": {
          "data-icon-name": iconName
        }
      }, _objectSpread2(_objectSpread2({}, ctx.data), {}, {
        props: containerProps
      }), {
        "class": classNames.root
      }]), [isImage // @ts-ignore
      ? h(ImageType, {
        "props": _objectSpread2({}, imageProps)
      }) : ctx.scopedSlots.default && ctx.scopedSlots.default({}) || (typeof iconContentChildren === 'function' ? iconContentChildren(h) : iconContentChildren)]);
    }
  }]);

  return Icon;
}(StatelessComponent$1);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], Icon.prototype, "iconName", void 0);

__decorate([Prop({
  type: Object,
  default: null
}), __metadata("design:type", Object)], Icon.prototype, "imageProps", void 0);

__decorate([Prop({
  type: [String, Object],
  default: null
}), __metadata("design:type", Object)], Icon.prototype, "imageErrorAs", void 0);

Icon = __decorate([Component], Icon);
var Icon$1 = Icon;

export default Icon$1;
