import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import lib from '../../../node_modules/vue-tsx-support/lib/index.js';
import BaseComponent$1 from '../BaseComponent.js';
import { MountingPortal } from 'portal-vue';
import { registerLayer, unregisterLayer, getDefaultTarget } from './Layer.notification.js';
import { getStyles } from './Layer.styles.js';

var getClassNames = classNamesFunction();
var TypedMountingPortal = lib.ofType().convert(MountingPortal);

var LayerBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(LayerBase, _BaseComponent);

  var _super = _createSuper(LayerBase);

  function LayerBase() {
    var _this;

    _classCallCheck(this, LayerBase);

    _this = _super.apply(this, arguments);
    _this.hasTarget = false;
    return _this;
  }

  _createClass(LayerBase, [{
    key: "mounted",
    value: function mounted() {
      this.createElement();

      if (this.hostId) {
        registerLayer(this.hostId, this.createElement);
      }
    }
  }, {
    key: "beforeDestroy",
    value: function beforeDestroy() {
      var hostId = this.hostId;

      if (this.hostId) {
        unregisterLayer(this.hostId, this.createElement);
      }
    }
  }, {
    key: "createElement",
    value: function createElement() {
      var doc = this.$el.ownerDocument;
      var host = this.getHost();

      if (!doc || !host) {
        this.hasTarget = false;
        return;
      }

      this.hasTarget = true;
    }
  }, {
    key: "getHost",
    value: function getHost() {
      var doc = this.$el.ownerDocument;

      if (!doc) {
        return undefined;
      }

      if (this.hostId) {
        return doc.getElementById(this.hostId);
      } else {
        var defaultHostSelector = getDefaultTarget();
        return defaultHostSelector ? doc.querySelector(defaultHostSelector) : doc.body;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      if (!this.hasTarget) return;
      var classNames = this.classNames,
          hostId = this.hostId,
          append = this.append;
      return h(TypedMountingPortal, {
        "attrs": {
          "mount-to": hostId ? "#".concat(hostId) : 'body',
          "append": append
        }
      }, [h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.content
      }, [this.$slots.default])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var className = this.className,
          theme = this.theme;
      return getClassNames(getStyles, {
        theme: theme,
        className: className,
        isNotHost: !this.hostId
      });
    }
  }]);

  return LayerBase;
}(BaseComponent$1);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], LayerBase.prototype, "hostId", void 0);

__decorate([Prop({
  type: Boolean,
  default: true
}), __metadata("design:type", Boolean)], LayerBase.prototype, "append", void 0);

LayerBase = __decorate([Component], LayerBase);

export { LayerBase };
