import { defineProperty as _defineProperty, inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { Icon } from '../Icon/index.js';
import { IconButton as IconButton$1 } from '../Button/IconButton/IconButton.js';
import { MessageBarType } from './MessageBar.types.js';

var _ICON_MAP;
var getClassNames = classNamesFunction();
var ICON_MAP = (_ICON_MAP = {}, _defineProperty(_ICON_MAP, MessageBarType.info, 'Info'), _defineProperty(_ICON_MAP, MessageBarType.warning, 'Info'), _defineProperty(_ICON_MAP, MessageBarType.error, 'ErrorBadge'), _defineProperty(_ICON_MAP, MessageBarType.blocked, 'Blocked2'), _defineProperty(_ICON_MAP, MessageBarType.severeWarning, 'Warning'), _defineProperty(_ICON_MAP, MessageBarType.success, 'Completed'), _ICON_MAP);

var MessageBarBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(MessageBarBase, _BaseComponent);

  var _super = _createSuper(MessageBarBase);

  function MessageBarBase() {
    var _this;

    _classCallCheck(this, MessageBarBase);

    _this = _super.apply(this, arguments);
    _this.state = {
      expandSingleLine: _this.expandSingleLine
    };
    return _this;
  }

  _createClass(MessageBarBase, [{
    key: "onExpandSingleLine",
    value: function onExpandSingleLine(value) {
      this.state.expandSingleLine = value;
    }
  }, {
    key: "onClick",
    value: function onClick() {
      this.state.expandSingleLine = !this.state.expandSingleLine;
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var theme = this.theme,
          classNames = this.classNames,
          messageBarType = this.messageBarType,
          actions = this.actions,
          truncated = this.truncated,
          isMultiline = this.isMultiline;
      return h("div", {
        "style": {
          background: theme.semanticColors.bodyBackground
        }
      }, [h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.content
      }, [h("div", {
        "class": classNames.iconContainer
      }, [h(Icon, {
        "class": classNames.icon,
        "attrs": {
          "icon-name": ICON_MAP[messageBarType]
        }
      })]), h("div", {
        "class": classNames.text,
        "attrs": {
          "role": "status"
        }
      }, [h("span", {
        "class": classNames.innerText
      }, [h("span", [this.$slots.default])])]), !actions && truncated && h("div", {
        "class": classNames.expandSingleLine
      }, [h(IconButton$1, {
        "class": classNames.expand,
        "attrs": {
          "icon-props": {
            iconName: this.state.expandSingleLine ? 'DoubleChevronUp' : 'DoubleChevronDown'
          }
        },
        "nativeOn": {
          "click": this.onClick
        }
      })]), !isMultiline && this.$slots.actions && h("div", {
        "class": classNames.actions
      }, [this.$slots.actions]), this.$listeners.dismiss && isMultiline && h(IconButton$1, {
        "class": classNames.dismissal,
        "attrs": {
          "icon-props": {
            iconName: 'Clear'
          }
        }
      }), this.$listeners.dismiss && !isMultiline && h("div", {
        "class": classNames.dismissSingleLine
      }, [h(IconButton$1, {
        "class": classNames.dismissal,
        "attrs": {
          "icon-props": {
            iconName: 'Clear'
          }
        }
      })])]), isMultiline && this.$slots.actions && h("div", {
        "class": classNames.actions
      }, [this.$slots.actions])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          className = this.className,
          messageBarType = this.messageBarType,
          actions = this.actions,
          truncated = this.truncated,
          isMultiline = this.isMultiline;
      var expandSingleLine = this.state.expandSingleLine;
      return getClassNames(this.styles, {
        theme: theme,
        messageBarType: messageBarType || MessageBarType.info,
        onDismiss: this.$listeners.dismiss !== undefined,
        actions: actions !== undefined,
        truncated: truncated,
        isMultiline: isMultiline,
        expandSingleLine: expandSingleLine,
        className: className
      });
    }
  }]);

  return MessageBarBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Number,
  default: MessageBarType.info
}), __metadata("design:type", Number)], MessageBarBase.prototype, "messageBarType", void 0);

__decorate([Prop({
  type: Boolean,
  default: true
}), __metadata("design:type", Boolean)], MessageBarBase.prototype, "isMultiline", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], MessageBarBase.prototype, "actions", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], MessageBarBase.prototype, "truncated", void 0);

__decorate([Prop({
  type: Boolean,
  default: true
}), __metadata("design:type", Boolean)], MessageBarBase.prototype, "expandSingleLine", void 0);

__decorate([Watch('expandSingleLine'), __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean]), __metadata("design:returntype", void 0)], MessageBarBase.prototype, "onExpandSingleLine", null);

MessageBarBase = __decorate([Component({
  components: {
    Icon: Icon,
    IconButton: IconButton$1
  }
})], MessageBarBase);

export { MessageBarBase };
