import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { PersonaSize, PersonaPresence } from './Persona.types.js';
import { PersonaCoin } from './PersonaCoin/index.js';

var getClassNames = classNamesFunction();

var PersonaBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(PersonaBase, _BaseComponent);

  var _super = _createSuper(PersonaBase);

  function PersonaBase() {
    var _this;

    _classCallCheck(this, PersonaBase);

    _this = _super.apply(this, arguments);
    _this.PersonaSize = PersonaSize;
    return _this;
  }

  _createClass(PersonaBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          coinSize = this.coinSize,
          text = this.text,
          secondaryText = this.secondaryText,
          tertiaryText = this.tertiaryText,
          optionalText = this.optionalText,
          hidePersonaDetails = this.hidePersonaDetails,
          size = this.size;
      return h("div", {
        "class": classNames.root,
        "style": coinSize ? {
          height: "".concat(coinSize, "px"),
          minWidth: "".concat(coinSize, "px")
        } : {}
      }, [h(PersonaCoin, {
        "props": _objectSpread2({}, this.$props)
      }), (!hidePersonaDetails || size === PersonaSize.size8 || size === PersonaSize.size10 || size === PersonaSize.tiny) && h("div", {
        "class": classNames.details
      }, [h("div", {
        "attrs": {
          "dir": "auto"
        },
        "class": classNames.primaryText
      }, [h("div", [text])]), h("div", {
        "attrs": {
          "dir": "auto"
        },
        "class": classNames.secondaryText
      }, [h("div", [secondaryText])]), h("div", {
        "attrs": {
          "dir": "auto"
        },
        "class": classNames.tertiaryText
      }, [h("div", [tertiaryText])]), h("div", {
        "attrs": {
          "dir": "auto"
        },
        "class": classNames.optionalText
      }, [h("div", [optionalText])]), this.$slots.default])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          className = this.className,
          showSecondaryText = this.showSecondaryText,
          presence = this.presence,
          size = this.size;
      return getClassNames(this.styles, {
        theme: theme,
        className: className,
        showSecondaryText: showSecondaryText,
        presence: presence,
        size: size
      });
    }
  }]);

  return PersonaBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], PersonaBase.prototype, "allowPhoneInitials", void 0);

__decorate([Prop({
  type: Number,
  default: PersonaPresence.none
}), __metadata("design:type", Number)], PersonaBase.prototype, "presence", void 0);

__decorate([Prop({
  type: Number,
  default: PersonaSize.size48
}), __metadata("design:type", Number)], PersonaBase.prototype, "size", void 0);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], PersonaBase.prototype, "coinSize", void 0);

__decorate([Prop({
  type: [Number, String],
  default: undefined
}), __metadata("design:type", Number)], PersonaBase.prototype, "initialsColor", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], PersonaBase.prototype, "hidePersonaDetails", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], PersonaBase.prototype, "text", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], PersonaBase.prototype, "secondaryText", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], PersonaBase.prototype, "tertiaryText", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], PersonaBase.prototype, "optionalText", void 0);

__decorate([Prop({
  type: String,
  default: undefined
}), __metadata("design:type", String)], PersonaBase.prototype, "imageUrl", void 0);

__decorate([Prop({
  type: String,
  default: 'online'
}), __metadata("design:type", String)], PersonaBase.prototype, "status", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], PersonaBase.prototype, "isOutOfOffice", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], PersonaBase.prototype, "showSecondaryText", void 0);

PersonaBase = __decorate([Component], PersonaBase);

export { PersonaBase };
