import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction, getRTL, getInitials } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../../BaseComponent.js';
import { mergeStyles as mergeStyles$1 } from '@uifabric/merge-styles';
import { ImageFit } from '../../Image/Image.types.js';
import { Image } from '../../Image/index.js';
import { Icon } from '../../Icon/index.js';
import { PersonaSize, PersonaPresence as PersonaPresence$1 } from '../Persona.types.js';
import { getPersonaInitialsColor } from '../PersonaInitialsColor.js';
import { sizeToPixels } from '../PersonaConsts.js';
import { PersonaPresence } from '../PersonaPresence/index.js';

var getClassNames = classNamesFunction({
  // There can be many PersonaCoin rendered with different sizes.
  // Therefore setting a larger cache size.
  cacheSize: 100
});

var PersonaCoinBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(PersonaCoinBase, _BaseComponent);

  var _super = _createSuper(PersonaCoinBase);

  function PersonaCoinBase() {
    var _this;

    _classCallCheck(this, PersonaCoinBase);

    _this = _super.apply(this, arguments);
    _this.mergeStyles = mergeStyles$1;
    _this.getPersonaInitialsColor = getPersonaInitialsColor;
    _this.PersonaSize = PersonaSize;
    _this.ImageFit = ImageFit;
    return _this;
  }

  _createClass(PersonaCoinBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          size = this.size,
          initials = this.initials,
          presence = this.presence,
          personaPresenceProps = this.personaPresenceProps,
          coinSizeStyle = this.coinSizeStyle,
          shouldRenderInitials = this.shouldRenderInitials,
          showUnknownPersonaCoin = this.showUnknownPersonaCoin,
          imageUrl = this.imageUrl,
          dimension = this.dimension;
      return h("div", {
        "attrs": {
          "role": "presentation"
        },
        "class": classNames.coin
      }, [size !== PersonaSize.size8 ? h("div", {
        "attrs": {
          "role": "presentation"
        },
        "class": classNames.imageArea,
        "style": coinSizeStyle
      }, [shouldRenderInitials && h("div", {
        "class": mergeStyles$1(classNames.initials, !showUnknownPersonaCoin && {
          backgroundColor: getPersonaInitialsColor(this.$props)
        }),
        "style": coinSizeStyle,
        "attrs": {
          "aria-hidden": "true"
        }
      }, [initials ? h("span", [initials]) : h(Icon, {
        "attrs": {
          "icon-name": "Contact"
        }
      })]), imageUrl && h(Image, {
        "class": classNames.image,
        "attrs": {
          "image-fit": ImageFit.cover,
          "src": imageUrl,
          "width": dimension,
          "height": dimension
        }
      }), h(PersonaPresence, {
        "props": _objectSpread2({}, personaPresenceProps)
      })]) : presence ? h(PersonaPresence, {
        "props": _objectSpread2({}, personaPresenceProps)
      }) : h(Icon, {
        "attrs": {
          "icon-name": "Contact"
        },
        "class": classNames.size10WithoutPresenceIcon
      }), this.$slots.default]);
    }
  }, {
    key: "initials",
    get: function get() {
      var imageInitials = this.imageInitials,
          allowPhoneInitials = this.allowPhoneInitials,
          showUnknownPersonaCoin = this.showUnknownPersonaCoin;
      var isRTL = getRTL(this.theme);
      return imageInitials || getInitials(this.text, isRTL, allowPhoneInitials);
    }
  }, {
    key: "dimension",
    get: function get() {
      var coinSize = this.coinSize,
          size = this.size;
      return coinSize || sizeToPixels[size];
    }
  }, {
    key: "personaPresenceProps",
    get: function get() {
      var coinSize = this.coinSize,
          theme = this.theme,
          isOutOfOffice = this.isOutOfOffice,
          presence = this.presence,
          presenceTitle = this.presenceTitle,
          size = this.size;
      return {
        coinSize: coinSize,
        isOutOfOffice: isOutOfOffice,
        presence: presence,
        presenceTitle: presenceTitle,
        size: size,
        theme: theme
      };
    }
  }, {
    key: "shouldRenderInitials",
    get: function get() {
      return !this.imageUrl;
    }
  }, {
    key: "coinSizeStyle",
    get: function get() {
      var coinSize = this.coinSize;
      return coinSize ? {
        width: coinSize,
        height: coinSize
      } : undefined;
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className,
          coinProps = this.coinProps,
          size = this.size,
          coinSize = this.coinSize,
          showUnknownPersonaCoin = this.showUnknownPersonaCoin;
      return getClassNames(styles, {
        theme: theme,
        className: coinProps && coinProps.className ? coinProps.className : className,
        size: size,
        coinSize: coinSize,
        showUnknownPersonaCoin: showUnknownPersonaCoin
      });
    }
  }]);

  return PersonaCoinBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], PersonaCoinBase.prototype, "allowPhoneInitials", void 0);

__decorate([Prop({
  type: Number,
  default: PersonaPresence$1.none
}), __metadata("design:type", Number)], PersonaCoinBase.prototype, "presence", void 0);

__decorate([Prop({
  type: Number,
  default: null
}), __metadata("design:type", Number)], PersonaCoinBase.prototype, "size", void 0);

__decorate([Prop({
  type: Number,
  default: null
}), __metadata("design:type", Number)], PersonaCoinBase.prototype, "coinSize", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaCoinBase.prototype, "coinProps", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaCoinBase.prototype, "showUnknownPersonaCoin", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaCoinBase.prototype, "isOutOfOffice", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaCoinBase.prototype, "presenceTitle", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaCoinBase.prototype, "imageUrl", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaCoinBase.prototype, "imageInitials", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaCoinBase.prototype, "text", void 0);

__decorate([Prop(), __metadata("design:type", Object)], PersonaCoinBase.prototype, "initialsColor", void 0);

PersonaCoinBase = __decorate([Component({
  inheritAttrs: false,
  components: {
    Icon: Icon,
    OImage: Image,
    PersonaPresence: PersonaPresence
  }
})], PersonaCoinBase);

export { PersonaCoinBase };
