import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';

var getClassNames = classNamesFunction(); // if the percentComplete is near 0, don't animate it.
// This prevents animations on reset to 0 scenarios

var ZERO_THRESHOLD = 0.01;

var ProgressIndicatorBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ProgressIndicatorBase, _BaseComponent);

  var _super = _createSuper(ProgressIndicatorBase);

  function ProgressIndicatorBase() {
    _classCallCheck(this, ProgressIndicatorBase);

    return _super.apply(this, arguments);
  }

  _createClass(ProgressIndicatorBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          label = this.label,
          progressHidden = this.progressHidden,
          progressBarStyles = this.progressBarStyles,
          description = this.description;
      return h("div", {
        "class": classNames.root
      }, [label && h("div", {
        "class": classNames.itemName
      }, [label]), !progressHidden && h("div", {
        "class": classNames.itemProgress
      }, [h("div", {
        "class": classNames.progressTrack
      }), h("div", {
        "class": classNames.progressBar,
        "style": progressBarStyles
      })]), description && h("div", {
        "class": classNames.itemDescription
      }, [description])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var className = this.className,
          indeterminate = this.indeterminate,
          theme = this.theme,
          barHeight = this.barHeight;
      return getClassNames(this.styles, {
        className: className,
        indeterminate: indeterminate,
        theme: theme,
        barHeight: barHeight
      });
    }
  }, {
    key: "progressBarStyles",
    get: function get() {
      var percentComplete = this.percentComplete;
      return {
        width: percentComplete !== undefined ? percentComplete + '%' : undefined,
        transition: percentComplete !== undefined && percentComplete < ZERO_THRESHOLD ? 'none' : undefined
      };
    }
  }]);

  return ProgressIndicatorBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ProgressIndicatorBase.prototype, "progressHidden", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ProgressIndicatorBase.prototype, "indeterminate", void 0);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], ProgressIndicatorBase.prototype, "percentComplete", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ProgressIndicatorBase.prototype, "label", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ProgressIndicatorBase.prototype, "description", void 0);

__decorate([Prop({
  type: Number,
  default: 2
}), __metadata("design:type", Number)], ProgressIndicatorBase.prototype, "barHeight", void 0);

ProgressIndicatorBase = __decorate([Component], ProgressIndicatorBase);

export { ProgressIndicatorBase };
