import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { Icon } from '../Icon/index.js';
import { IconButton as IconButton$1 } from '../Button/IconButton/IconButton.js';

var getClassNames = classNamesFunction();

var RatingBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(RatingBase, _BaseComponent);

  var _super = _createSuper(RatingBase);

  function RatingBase() {
    var _this;

    _classCallCheck(this, RatingBase);

    _this = _super.apply(this, arguments);
    _this.internalValue = _this.rating;
    return _this;
  }

  _createClass(RatingBase, [{
    key: "getRatingIconName",
    value: function getRatingIconName(ratingLevel) {
      return this.internalValue >= ratingLevel ? this.iconName : this.unselectedIconName;
    }
  }, {
    key: "getRatingFillPercentage",
    value: function getRatingFillPercentage(ratingLevel) {
      if (ratingLevel - this.internalValue <= 0) return '100%';
      if (ratingLevel - this.internalValue > 1) return '0%';
      if (ratingLevel - this.internalValue > 0) return "".concat((1 - (ratingLevel - this.internalValue)) * 100, "%");
    }
  }, {
    key: "setRating",
    value: function setRating(rating) {
      this.internalValue = rating;
    }
  }, {
    key: "onPropValueChanged",
    value: function onPropValueChanged(newValue) {
      this.internalValue = newValue;
    }
  }, {
    key: "onValueChanged",
    value: function onValueChanged(value) {
      this.$emit('input', value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var classNames = this.classNames,
          readonly = this.readonly,
          max = this.max,
          size = this.size,
          disabled = this.disabled,
          iconName = this.iconName;
      return h("div", {
        "attrs": {
          "area-label": "areaLabel"
        },
        "class": classNames.root,
        "style": {
          '--size': "".concat(size, "px")
        }
      }, [h("div", {
        "class": classNames.ratingFocusZone
      }, [this.ratingLevels.map(function (ratingLevel) {
        return h("button", {
          "key": ratingLevel,
          "attrs": _objectSpread2(_objectSpread2({}, _this2.$attrs), {}, {
            "disabled": disabled
          }),
          "class": classNames.ratingButton,
          "on": {
            "click": function click() {
              !disabled && !readonly && _this2.setRating(ratingLevel);
            }
          }
        }, [h("span", {
          "class": classNames.labelText
        }, ["Select ".concat(ratingLevel, " of ").concat(max)]), h("div", {
          "class": classNames.ratingStar
        }, [h(Icon, {
          "attrs": {
            "icon-name": _this2.getRatingIconName(ratingLevel)
          },
          "class": classNames.ratingStarBack
        }), h(Icon, {
          "attrs": {
            "icon-name": iconName
          },
          "class": classNames.ratingStarFront,
          "style": {
            width: _this2.getRatingFillPercentage(ratingLevel)
          }
        })])]);
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var disabled = this.disabled,
          readonly = this.readonly,
          theme = this.theme;
      return getClassNames(this.styles, {
        disabled: disabled,
        readOnly: readonly,
        theme: theme
      });
    }
  }, {
    key: "ratingLevels",
    get: function get() {
      var min = this.min,
          max = this.max;
      if (min < 0 || max <= min) return [];
      var i = min + 1;
      return Array(max - min).fill(undefined).map(function () {
        return i++;
      });
    }
  }, {
    key: "areaLabel",
    get: function get() {
      if (!this.ariaLabelFormat) return '';
      return this.ariaLabelFormat.replace('{0}', "".concat(this.internalValue)).replace('{1}', "".concat(this.max));
    }
  }]);

  return RatingBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Number,
  default: 16
}), __metadata("design:type", Number)], RatingBase.prototype, "size", void 0);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], RatingBase.prototype, "min", void 0);

__decorate([Prop({
  type: Number,
  default: 10
}), __metadata("design:type", Number)], RatingBase.prototype, "max", void 0);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], RatingBase.prototype, "rating", void 0);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], RatingBase.prototype, "ariaLabelFormat", void 0);

__decorate([Prop({
  type: String,
  default: 'FavoriteStarFill'
}), __metadata("design:type", String)], RatingBase.prototype, "iconName", void 0);

__decorate([Prop({
  type: String,
  default: 'FavoriteStar'
}), __metadata("design:type", String)], RatingBase.prototype, "unselectedIconName", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], RatingBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], RatingBase.prototype, "readonly", void 0);

__decorate([Watch('rating'), __metadata("design:type", Function), __metadata("design:paramtypes", [Number]), __metadata("design:returntype", void 0)], RatingBase.prototype, "onPropValueChanged", null);

__decorate([Watch('internalValue'), __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], RatingBase.prototype, "onValueChanged", null);

RatingBase = __decorate([Component({
  components: {
    Icon: Icon,
    IconButton: IconButton$1
  },
  inheritAttrs: false
})], RatingBase);

export { RatingBase };
