import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction, KeyCodes } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import _mergeJSXProps$1 from '@vue/babel-helper-vue-jsx-merge-props';
import { Icon } from '../Icon/index.js';
import { IconButton as IconButton$1 } from '../Button/IconButton/IconButton.js';

var getClassNames = classNamesFunction();

var SearchBoxBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(SearchBoxBase, _BaseComponent);

  var _super = _createSuper(SearchBoxBase);

  function SearchBoxBase() {
    var _this;

    _classCallCheck(this, SearchBoxBase);

    _this = _super.apply(this, arguments);
    _this.isActive = false;
    _this.internalValue = _this.value;
    return _this;
  }

  _createClass(SearchBoxBase, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var classNames = this.classNames,
          disabled = this.disabled,
          internalValue = this.internalValue,
          placeholder = this.placeholder,
          iconName = this.iconName;
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.iconContainer,
        "attrs": {
          "role": "search"
        }
      }, [h(Icon, {
        "class": classNames.icon,
        "attrs": {
          "icon-name": iconName
        }
      })]), h("input", _mergeJSXProps$1([{
        "ref": "input"
      }, this.$attrs, {
        "class": classNames.field,
        "attrs": {
          "disabled": disabled,
          "area-label": placeholder,
          "placeholder": placeholder
        },
        "domProps": {
          "value": internalValue
        },
        "on": {
          "input": function input(ev) {
            return _this2.internalValue = ev.target.value;
          },
          "focus": this.onFocus,
          "blur": this.onBlur,
          "keydown": this.onKeyDown
        }
      }])), internalValue && h("div", {
        "class": classNames.clearButton
      }, [h(IconButton$1, {
        "attrs": {
          "styles": {
            root: {
              height: 'auto'
            },
            icon: {
              fontSize: '12px'
            }
          },
          "icon-props": {
            iconName: 'Clear'
          }
        },
        "nativeOn": {
          "click": this.clearInput
        }
      })])]);
    }
  }, {
    key: "onPropValueChanged",
    value: function onPropValueChanged(newValue) {
      this.internalValue = newValue;
    }
  }, {
    key: "onValueChanged",
    value: function onValueChanged(value) {
      this.$emit('input', value);
      this.$emit('change', value);
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown(ev) {
      switch (ev.which) {
        case KeyCodes.escape:
          this.$emit('escape', ev);
          if (ev.defaultPrevented) return;else this.clearInput();
          break;

        case KeyCodes.enter:
          this.$emit('search', this.internalValue);
          return;

        default:
          if (!ev.defaultPrevented) {
            return;
          }

      } // We only get here if the keypress has been handled,
      // or preventDefault was called in case of default keyDown handler


      ev.preventDefault();
      ev.stopPropagation();
    }
  }, {
    key: "submit",
    value: function submit() {
      this.$emit('search', this.internalValue);
    }
  }, {
    key: "onEscape",
    value: function onEscape(e) {
      this.$emit('escape', e);
      if (e.defaultPrevented) return;
      this.clearInput();
    }
  }, {
    key: "clearInput",
    value: function clearInput(e) {
      this.$emit('clear', e);
      if (e && e.defaultPrevented) return;
      this.internalValue = '';
      this.$refs.input.focus();
    }
  }, {
    key: "onFocus",
    value: function onFocus(e) {
      this.$emit('focus', e);
      if (e.defaultPrevented) return;
      this.isActive = true;
    }
  }, {
    key: "onBlur",
    value: function onBlur(e) {
      this.$emit('blur', e);
      if (e.defaultPrevented) return;
      this.isActive = false;
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          underlined = this.underlined,
          disabled = this.disabled,
          isActive = this.isActive,
          className = this.className,
          disableAnimation = this.disableAnimation,
          internalValue = this.internalValue;
      return getClassNames(this.styles, {
        theme: theme,
        className: className,
        underlined: underlined,
        hasFocus: isActive,
        disabled: disabled,
        hasInput: internalValue == null ? false : internalValue.length > 0,
        disableAnimation: disableAnimation
      });
    }
  }]);

  return SearchBoxBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], SearchBoxBase.prototype, "underlined", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], SearchBoxBase.prototype, "defaultValue", void 0);

__decorate([Prop({
  type: String,
  default: 'Search'
}), __metadata("design:type", String)], SearchBoxBase.prototype, "placeholder", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], SearchBoxBase.prototype, "value", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], SearchBoxBase.prototype, "disableAnimation", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], SearchBoxBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: String,
  default: 'Search'
}), __metadata("design:type", String)], SearchBoxBase.prototype, "iconName", void 0);

__decorate([Watch('value'), __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], SearchBoxBase.prototype, "onPropValueChanged", null);

__decorate([Watch('internalValue'), __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], SearchBoxBase.prototype, "onValueChanged", null);

SearchBoxBase = __decorate([Component({
  components: {
    Icon: Icon,
    IconButton: IconButton$1
  },
  inheritAttrs: false
})], SearchBoxBase);

export { SearchBoxBase };
