import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { ShimmerElementsGroup as ShimmerElementsGroup$1 } from './ShimmerElementsGroup/ShimmerElementsGroup.js';

var getClassNames = classNamesFunction();
var TRANSITION_ANIMATION_INTERVAL = 200;
/* ms */

var ShimmerBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ShimmerBase, _BaseComponent);

  var _super = _createSuper(ShimmerBase);

  function ShimmerBase() {
    var _this;

    _classCallCheck(this, ShimmerBase);

    _this = _super.apply(this, arguments);
    _this.contentLoaded = _this.isDataLoaded;
    return _this;
  }

  _createClass(ShimmerBase, [{
    key: "beforeDestroy",
    value: function beforeDestroy() {
      this._async.dispose();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(newVal, oldVal) {
      var _this2 = this;

      if (newVal === oldVal) return;

      if (this.isDataLoaded) {
        this.lastTimeoutId = this._async.setTimeout(function () {
          _this2.contentLoaded = _this2.isDataLoaded;
        }, TRANSITION_ANIMATION_INTERVAL);
      } else {
        this.contentLoaded = this.isDataLoaded;
      }
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          width = this.width,
          shimmerElements = this.shimmerElements,
          shimmerColors = this.shimmerColors;
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "style": {
          width: width || '100%'
        },
        "class": classNames.shimmerWrapper
      }, [h("div", {
        "class": classNames.shimmerGradient
      }), h(ShimmerElementsGroup$1, {
        "attrs": {
          "shimmer-elements": shimmerElements,
          "background-color": shimmerColors && shimmerColors.background
        }
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          styles = this.styles,
          className = this.className,
          shimmerColors = this.shimmerColors;
      return getClassNames(styles, {
        theme: theme,
        isDataLoaded: false,
        className: className,
        transitionAnimationInterval: TRANSITION_ANIMATION_INTERVAL,
        shimmerColor: shimmerColors && shimmerColors.shimmer,
        shimmerWaveColor: shimmerColors && shimmerColors.shimmerWave
      });
    }
  }]);

  return ShimmerBase;
}(BaseComponent$1);

__decorate([Prop({
  default: null
}), __metadata("design:type", Object)], ShimmerBase.prototype, "shimmerColors", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ShimmerBase.prototype, "isDataLoaded", void 0);

__decorate([Prop({
  type: Array,
  default: function _default() {
    return [];
  }
}), __metadata("design:type", Array)], ShimmerBase.prototype, "shimmerElements", void 0);

__decorate([Prop({
  type: [Number, String],
  default: null
}), __metadata("design:type", Object)], ShimmerBase.prototype, "width", void 0);

__decorate([Watch('isDataLoaded'), __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean, Boolean]), __metadata("design:returntype", void 0)], ShimmerBase.prototype, "componentDidUpdate", null);

ShimmerBase = __decorate([Component({
  components: {
    ShimmerElementsGroup: ShimmerElementsGroup$1
  }
})], ShimmerBase);

export { ShimmerBase };
