import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent$1 from '../StatelessComponent.js';
import { DelayedRender as DelayedRender$1 } from '../DelayedRender.js';

var getClassNames = classNamesFunction();

var Spinner = /*#__PURE__*/function (_StatelessComponent) {
  _inherits(Spinner, _StatelessComponent);

  var _super = _createSuper(Spinner);

  function Spinner() {
    _classCallCheck(this, Spinner);

    return _super.apply(this, arguments);
  }

  _createClass(Spinner, [{
    key: "render",
    value: function render(h, context) {
      var _context$props = context.props,
          theme = _context$props.theme,
          styles = _context$props.styles,
          className = _context$props.className,
          ariaLabel = _context$props.ariaLabel,
          ariaLive = _context$props.ariaLive,
          size = _context$props.size,
          label = _context$props.label,
          labelPosition = _context$props.labelPosition;
      var statusMessage = ariaLabel;
      var classNames = getClassNames(styles, {
        theme: theme,
        size: size,
        className: className,
        labelPosition: labelPosition
      });
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.circle
      }), (context.scopedSlots.default || label) && h("div", {
        "class": classNames.label
      }, [context.scopedSlots.default ? context.scopedSlots.default({}) : label]), statusMessage && h("div", {
        "attrs": {
          "role": "status",
          "aria-live": ariaLive
        }
      }, [h(DelayedRender$1, [h("div", {
        "class": classNames.screenReaderText
      }, [statusMessage])])])]);
    }
  }]);

  return Spinner;
}(StatelessComponent$1);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], Spinner.prototype, "label", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], Spinner.prototype, "ariaLabel", void 0);

__decorate([Prop({
  type: String,
  default: 'polite',
  validator: function validator(v) {
    return ['assertive', 'polite', 'off'].indexOf(v) > -1;
  }
}), __metadata("design:type", String)], Spinner.prototype, "ariaLive", void 0);

__decorate([Prop({
  type: String,
  default: 'bottom'
}), __metadata("design:type", String)], Spinner.prototype, "labelPosition", void 0);

__decorate([Prop({
  type: Number,
  default: 20
}), __metadata("design:type", Number)], Spinner.prototype, "size", void 0);

Spinner = __decorate([Component], Spinner);
var SpinnerBase = Spinner;

export default SpinnerBase;
