import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass, objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { mergeStyleSets } from '@uifabric/styling';
import StatelessComponent$1 from '../StatelessComponent.js';
import { styles } from './Stack.styles.js';

var getClassNames = classNamesFunction();

var Stack = /*#__PURE__*/function (_StatelessComponent) {
  _inherits(Stack, _StatelessComponent);

  var _super = _createSuper(Stack);

  function Stack() {
    _classCallCheck(this, Stack);

    return _super.apply(this, arguments);
  }

  _createClass(Stack, [{
    key: "render",
    value: function render(h, ctx) {
      var _ctx$props = ctx.props,
          theme = _ctx$props.theme,
          tokens = _ctx$props.tokens,
          verticalFill = _ctx$props.verticalFill,
          horizontal = _ctx$props.horizontal,
          reversed = _ctx$props.reversed,
          grow = _ctx$props.grow,
          wrap = _ctx$props.wrap,
          horizontalAlign = _ctx$props.horizontalAlign,
          verticalAlign = _ctx$props.verticalAlign,
          disableShrink = _ctx$props.disableShrink,
          className = _ctx$props.className;
      var classNames = getClassNames(mergeStyleSets(styles({
        className: className,
        verticalFill: verticalFill,
        horizontal: horizontal,
        reversed: reversed,
        grow: grow,
        wrap: wrap,
        horizontalAlign: horizontalAlign,
        verticalAlign: verticalAlign,
        disableShrink: disableShrink
      }, theme, tokens), ctx.props.styles));
      return h('div', _objectSpread2(_objectSpread2({}, ctx.data), {}, {
        class: classNames.root
      }), ctx.children);
    }
  }]);

  return Stack;
}(StatelessComponent$1);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], Stack.prototype, "verticalFill", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], Stack.prototype, "horizontal", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], Stack.prototype, "reversed", void 0);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], Stack.prototype, "childrenGap", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], Stack.prototype, "grow", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], Stack.prototype, "wrap", void 0);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], Stack.prototype, "horizontalAlign", void 0);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], Stack.prototype, "verticalAlign", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], Stack.prototype, "disableShrink", void 0);

__decorate([Prop({
  type: Object,
  default: function _default() {}
}), __metadata("design:type", Object)], Stack.prototype, "tokens", void 0);

Stack = __decorate([Component({
  components: {}
})], Stack);

export { Stack };
