import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { memoizeFunction, classNamesFunction } from '@uifabric-vue/utilities';
import { mergeStyleSets } from '@uifabric/styling';
import BaseComponent$1 from '../../BaseComponent.js';
import { getStyles } from '../../Button/ActionButton/ActionButton.styles.js';
import { GridCell as GridCell$1 } from '../../../utilities/grid/GridCell.js';
import { getColorFromString as getColorFromString$1 } from '../../../utilities/color/getColorFromString.js';

var getColorPickerGridCellButtonClassNames = memoizeFunction(function (theme, className, variantClassName, iconClassName, menuIconClassName, disabled, checked, expanded, isSplit) {
  var styles = getStyles(theme);
  return mergeStyleSets({
    root: ['ms-Button', styles.root, variantClassName, className, checked && ['is-checked', styles.rootChecked], disabled && ['is-disabled', styles.rootDisabled], !disabled && !checked && {
      selectors: {
        ':hover': styles.rootHovered,
        ':focus': styles.rootFocused,
        ':active': styles.rootPressed
      }
    }, disabled && checked && [styles.rootCheckedDisabled], !disabled && checked && {
      selectors: {
        ':hover': styles.rootCheckedHovered,
        ':active': styles.rootCheckedPressed
      }
    }],
    flexContainer: ['ms-Button-flexContainer', styles.flexContainer]
  });
});
var getClassNames = classNamesFunction();

var ColorPickerGridCellBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ColorPickerGridCellBase, _BaseComponent);

  var _super = _createSuper(ColorPickerGridCellBase);

  function ColorPickerGridCellBase() {
    _classCallCheck(this, ColorPickerGridCellBase);

    return _super.apply(this, arguments);
  }

  _createClass(ColorPickerGridCellBase, [{
    key: "isWhiteCell",
    value: function isWhiteCell(inputColor) {
      var color = getColorFromString$1(inputColor);
      return color.hex === 'ffffff';
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          color = this.color,
          circle = this.circle;
      return h(GridCell$1, {
        "class": classNames.colorCell
      }, [h("svg", {
        "class": classNames.svg,
        "attrs": {
          "viewBox": "0 0 20 20",
          "fill": getColorFromString$1(color).str
        }
      }, [circle ? h("circle", {
        "attrs": {
          "cx": "50%",
          "cy": "50%",
          "r": "50%"
        }
      }) : h("rect", {
        "attrs": {
          "width": "100%",
          "height": "100%"
        }
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          circle = this.circle,
          color = this.color,
          disabled = this.disabled,
          selected = this.selected,
          height = this.height,
          width = this.width,
          borderWidth = this.borderWidth;
      return getClassNames(styles, {
        theme: theme,
        disabled: disabled,
        selected: selected,
        circle: circle,
        isWhite: this.isWhiteCell(color),
        height: height,
        width: width,
        borderWidth: borderWidth
      });
    }
  }]);

  return ColorPickerGridCellBase;
}(BaseComponent$1);

__decorate([Prop({
  type: Boolean,
  default: true
}), __metadata("design:type", Boolean)], ColorPickerGridCellBase.prototype, "circle", void 0);

__decorate([Prop({
  type: String
}), __metadata("design:type", String)], ColorPickerGridCellBase.prototype, "color", void 0);

__decorate([Prop({
  type: Boolean
}), __metadata("design:type", Boolean)], ColorPickerGridCellBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean
}), __metadata("design:type", Boolean)], ColorPickerGridCellBase.prototype, "selected", void 0);

__decorate([Prop({
  type: Number,
  default: 20
}), __metadata("design:type", Number)], ColorPickerGridCellBase.prototype, "height", void 0);

__decorate([Prop({
  type: Number,
  default: 20
}), __metadata("design:type", Number)], ColorPickerGridCellBase.prototype, "width", void 0);

__decorate([Prop({
  type: Number,
  default: 2
}), __metadata("design:type", Number)], ColorPickerGridCellBase.prototype, "borderWidth", void 0);

ColorPickerGridCellBase = __decorate([Component({
  components: {
    GridCell: GridCell$1
  }
})], ColorPickerGridCellBase);

export { ColorPickerGridCellBase };
