import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import _mergeJSXProps$1 from '@vue/babel-helper-vue-jsx-merge-props';
import { Grid as Grid$1 } from '../../utilities/grid/Grid.js';
import { ColorPickerGridCell as ColorPickerGridCell$1 } from './ColorPickerGridCell/ColorPickerGridCell.js';

var getClassNames = classNamesFunction();

var SwatchColorPickerBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(SwatchColorPickerBase, _BaseComponent);

  var _super = _createSuper(SwatchColorPickerBase);

  function SwatchColorPickerBase() {
    _classCallCheck(this, SwatchColorPickerBase);

    return _super.apply(this, arguments);
  }

  _createClass(SwatchColorPickerBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var colorCells = this.colorCells,
          columnCount = this.columnCount,
          cellShape = this.cellShape,
          cellWidth = this.cellWidth,
          cellHeight = this.cellHeight;
      return h(Grid$1, _mergeJSXProps$1([{
        "attrs": {
          "items": colorCells,
          "column-count": columnCount
        }
      }, {
        scopedSlots: {
          default: function _default(_ref) {
            var item = _ref.cell;
            return h(ColorPickerGridCell$1, {
              "attrs": {
                "color": item.color,
                "circle": cellShape === 'circle',
                "width": cellWidth,
                "height": cellHeight
              }
            });
          }
        }
      }]));
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          styles = this.styles,
          className = this.className,
          cellMargin = this.cellMargin;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        cellMargin: cellMargin
      });
    }
  }]);

  return SwatchColorPickerBase;
}(BaseComponent$1);

__decorate([Prop({
  default: 10
}), __metadata("design:type", Number)], SwatchColorPickerBase.prototype, "cellMargin", void 0);

__decorate([Prop({
  type: Array,
  default: function _default() {
    return [];
  }
}), __metadata("design:type", Array)], SwatchColorPickerBase.prototype, "colorCells", void 0);

__decorate([Prop({
  type: Number
}), __metadata("design:type", Number)], SwatchColorPickerBase.prototype, "columnCount", void 0);

__decorate([Prop({
  type: String,
  default: 'circle'
}), __metadata("design:type", String)], SwatchColorPickerBase.prototype, "cellShape", void 0);

__decorate([Prop({
  type: Number
}), __metadata("design:type", Number)], SwatchColorPickerBase.prototype, "cellHeight", void 0);

__decorate([Prop({
  type: Number
}), __metadata("design:type", Number)], SwatchColorPickerBase.prototype, "cellWidth", void 0);

SwatchColorPickerBase = __decorate([Component({
  components: {
    Grid: Grid$1,
    ColorPickerGridCell: ColorPickerGridCell$1
  },
  inheritAttrs: false
})], SwatchColorPickerBase);

export { SwatchColorPickerBase };
