import { inherits as _inherits, createSuper as _createSuper, classCallCheck as _classCallCheck, createClass as _createClass } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { __decorate, __metadata } from '../../../../../node_modules/tslib/tslib.es6.js';
import { Model, Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent$1 from '../BaseComponent.js';
import { Label } from '../Label/index.js';

var getClassNames = classNamesFunction();

var ToggleBase = /*#__PURE__*/function (_BaseComponent) {
  _inherits(ToggleBase, _BaseComponent);

  var _super = _createSuper(ToggleBase);

  function ToggleBase() {
    var _this;

    _classCallCheck(this, ToggleBase);

    _this = _super.apply(this, arguments);
    _this.internalChecked = _this.defaultChecked || _this.checked;
    return _this;
  }

  _createClass(ToggleBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          internalChecked = this.internalChecked,
          disabled = this.disabled,
          label = this.label,
          onText = this.onText,
          offText = this.offText;
      return h("div", {
        "class": classNames.root
      }, [this.$scopedSlots.label ? this.$scopedSlots.label({
        checked: internalChecked,
        disabled: disabled,
        label: label
      }) : h(Label, {
        "class": classNames.label,
        "attrs": {
          "for": "Toggle".concat(this.uid)
        }
      }, [label]), h("div", {
        "class": classNames.container
      }, [h("button", {
        "attrs": {
          "id": "Toggle".concat(this.uid)
        },
        "ref": "toggleButton",
        "class": classNames.pill,
        "on": {
          "click": this.onClick
        }
      }, [h("div", {
        "class": classNames.thumb
      })]), (internalChecked && onText || !internalChecked && offText) && h(Label, {
        "class": classNames.text,
        "attrs": {
          "for": "Toggle".concat(this.uid)
        }
      }, [internalChecked ? onText : offText])])]);
    }
  }, {
    key: "focus",
    value: function focus() {
      this.$refs.toggleButton.focus();
    }
  }, {
    key: "onCheckedChanged",
    value: function onCheckedChanged(checked, prevVal) {
      this.$emit('input', checked);
    }
  }, {
    key: "onClick",
    value: function onClick() {
      if (this.disabled) return;
      this.internalChecked = !this.internalChecked;
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          className = this.className,
          disabled = this.disabled,
          internalChecked = this.internalChecked,
          inlineLabel = this.inlineLabel,
          onText = this.onText,
          offText = this.offText;
      return getClassNames(this.styles, {
        theme: theme,
        className: className,
        disabled: disabled,
        checked: internalChecked,
        inlineLabel: inlineLabel,
        onOffMissing: !onText && !offText
      });
    }
  }]);

  return ToggleBase;
}(BaseComponent$1);

__decorate([Model('input', {
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ToggleBase.prototype, "checked", void 0);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], ToggleBase.prototype, "label", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ToggleBase.prototype, "defaultChecked", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ToggleBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], ToggleBase.prototype, "inlineLabel", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ToggleBase.prototype, "onText", void 0);

__decorate([Prop({
  type: String,
  default: null
}), __metadata("design:type", String)], ToggleBase.prototype, "offText", void 0);

__decorate([Watch('internalChecked'), __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean, Boolean]), __metadata("design:returntype", void 0)], ToggleBase.prototype, "onCheckedChanged", null);

ToggleBase = __decorate([Component], ToggleBase);

export { ToggleBase };
