import { objectWithoutProperties as _objectWithoutProperties, objectSpread2 as _objectSpread2 } from '../../../../_virtual/_rollupPluginBabelHelpers.js';
import { Customizations } from '@uifabric-vue/utilities';
import lib from '../../node_modules/vue-tsx-support/lib/index.js';
import { concatStyleSetsWithProps } from '@uifabric/merge-styles';

var DefaultFields = ['theme', 'styles'];
function styled(Component, baseStyles, getProps, customizable, pure) {
  customizable = customizable || {
    scope: '',
    fields: undefined
  };
  var _customizable = customizable,
      scope = _customizable.scope,
      _customizable$fields = _customizable.fields,
      fields = _customizable$fields === void 0 ? DefaultFields : _customizable$fields;

  var _styles;

  var styledComponent = lib.componentFactory.create({
    name: "Styled".concat(Component.displayName || Component.name),
    functional: true,
    render: function render(h, context) {
      var settings = Customizations.getSettings(fields, scope);

      var customizedStyles = settings.styles,
          dir = settings.dir,
          rest = _objectWithoutProperties(settings, ["styles", "dir"]);

      var additionalProps = getProps ? getProps(this) : undefined;

      if (!_styles || customizedStyles !== _styles.__cachedInputs__[1] || !!context.props.styles) {
        _styles = function _styles(styleProps) {
          return concatStyleSetsWithProps(styleProps, baseStyles, context.props.styles);
        };

        _styles.__cachedInputs__ = [baseStyles, context.props.styles];
      }

      return h(Component, _objectSpread2(_objectSpread2({}, context.data), {}, {
        class: [context.props.className, context.data.class].filter(function (e) {
          return e;
        }).join(' '),
        props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, rest), additionalProps), context.props), {}, {
          className: [context.props.className, context.data.class].filter(function (e) {
            return e;
          }).join(' '),
          styles: _styles
        })
      }), context.children);
    }
  }); // styledComponent.prototype.BaseComponent = Component

  return styledComponent;
}

export { styled };
