import { MAX_COLOR_ALPHA } from './consts.js';
import { rgb2hsv as rgb2hsv$1 } from './rgb2hsv.js';
import { rgb2hex as rgb2hex$1 } from './rgb2hex.js';
import { _rgbaOrHexString as _rgbaOrHexString$1 } from './_rgbaOrHexString.js';

/** Converts an RGBA color to a color object (alpha defaults to 100). */

function getColorFromRGBA(rgba) {
  var _rgba$a = rgba.a,
      a = _rgba$a === void 0 ? MAX_COLOR_ALPHA : _rgba$a,
      b = rgba.b,
      g = rgba.g,
      r = rgba.r;

  var _rgb2hsv = rgb2hsv$1(r, g, b),
      h = _rgb2hsv.h,
      s = _rgb2hsv.s,
      v = _rgb2hsv.v;

  var hex = rgb2hex$1(r, g, b);

  var str = _rgbaOrHexString$1(r, g, b, a, hex);

  return {
    a: a,
    b: b,
    g: g,
    h: h,
    hex: hex,
    r: r,
    s: s,
    str: str,
    v: v
  };
}

export { getColorFromRGBA };
