import { objectSpread2 as _objectSpread2 } from '../../../../../_virtual/_rollupPluginBabelHelpers.js';
import { getColorFromRGBA as getColorFromRGBA$1 } from './getColorFromRGBA.js';
import { cssColor as cssColor$1 } from './cssColor.js';

/**
 * Converts a CSS color string to a color object.
 * Note that hex colors *must* be prefixed with # to be considered valid.
 *
 * `inputColor` will be used unmodified as the `str` property of the returned object.
 * Alpha defaults to 100 if not specified in `inputColor`.
 * Returns undefined if the color string is invalid/not recognized.
 */

function getColorFromString(inputColor) {
  var color = cssColor$1(inputColor);

  if (!color) {
    return;
  }

  return _objectSpread2(_objectSpread2({}, getColorFromRGBA$1(color)), {}, {
    str: inputColor
  });
}

export { getColorFromString };
